#include "B4RDefines.h"

namespace B4R {

    B4RString* B4RMDMAX72xxLedMatrix::StringToB4R(String* o) {
		PrintToMemory pm;
		B4RString* s = B4RString::PrintableToString(NULL);
		pm.print(*o);
		StackMemory::buffer[StackMemory::cp++] = 0;
		return s;
      
    }
    void B4RMDMAX72xxLedMatrix::Initialize(B4RString* HARDWARE_TYPE_b,int MAX_DEVICES, int CS_PIN){

    if (HARDWARE_TYPE_b->data=="PAROLA_HW"){
      led = new (be) MD_MAX72XX(MD_MAX72XX::FC16_HW,  CS_PIN, MAX_DEVICES);
		  led->begin();
      return;    
    }
    else if (HARDWARE_TYPE_b->data=="GENERIC_HW"){
      led = new (be) MD_MAX72XX(MD_MAX72XX::FC16_HW,  CS_PIN, MAX_DEVICES);
		  led->begin();
      return;    
    }
    else if (HARDWARE_TYPE_b->data=="ICSTATION_HW"){
      led = new (be) MD_MAX72XX(MD_MAX72XX::FC16_HW,  CS_PIN, MAX_DEVICES);
		  led->begin(); 
      return;   
    }
    else if (HARDWARE_TYPE_b->data=="FC16_HW"){
       led = new (be) MD_MAX72XX(MD_MAX72XX::FC16_HW,  CS_PIN, MAX_DEVICES);
		   led->begin();
       return; 
    } 
    ::Serial.println("wrong hardware type");
    }

    void B4RMDMAX72xxLedMatrix::Initialize2(B4RString* HARDWARE_TYPE_b,int MAX_DEVICES, int DATA_PIN, int CLK_PIN, int CS_PIN){
    ::Serial.println("init 2");
    if (HARDWARE_TYPE_b->data=="PAROLA_HW"){
      led = new (be) MD_MAX72XX(MD_MAX72XX::PAROLA_HW, DATA_PIN, CLK_PIN, CS_PIN, MAX_DEVICES);
		  led->begin();
      return;    
    }
    else if (HARDWARE_TYPE_b->data=="GENERIC_HW"){
      led = new (be) MD_MAX72XX(MD_MAX72XX::GENERIC_HW, DATA_PIN, CLK_PIN, CS_PIN, MAX_DEVICES);
		  led->begin();
      return;    
    }
    else if (HARDWARE_TYPE_b->data=="ICSTATION_HW"){
      led = new (be) MD_MAX72XX(MD_MAX72XX::ICSTATION_HW, DATA_PIN, CLK_PIN, CS_PIN, MAX_DEVICES);
		  led->begin(); 
      return;   
    }
    else if (HARDWARE_TYPE_b->data=="FC16_HW"){
       led = new (be) MD_MAX72XX(MD_MAX72XX::FC16_HW, DATA_PIN, CLK_PIN, CS_PIN, MAX_DEVICES);
		   led->begin();
       return; 
    } 
    ::Serial.println("wrong hardware type");
    }
    
    void B4RMDMAX72xxLedMatrix::clear(){
    led->clear();
    }

    uint B4RMDMAX72xxLedMatrix::setChar(byte col, byte c){
    return led->setChar(col, c);

    }
   bool B4RMDMAX72xxLedMatrix::setPoint(byte r, byte c,bool state){
    return led->setPoint(r, c, state);
    }
    
    bool B4RMDMAX72xxLedMatrix::setRow(byte r, byte value) {
    return led->setRow(r,value);
    }
    
    void B4RMDMAX72xxLedMatrix::wait(ulong waitms){
     ulong start = millis();
      while (millis() - start < waitms){
        yield();
      }
     }
    

    
    uint B4RMDMAX72xxLedMatrix::getDeviceCount(void) { 
    return led->getDeviceCount(); 
    }
    
    uint B4RMDMAX72xxLedMatrix::getColumnCount(void) {
    return led->getColumnCount();
    }
    
    bool B4RMDMAX72xxLedMatrix::setColum(byte c, byte value) {
    return led->setColumn(c, value); // { return setColumn((c / COL_SIZE), c % COL_SIZE, value); };
    } 
    bool B4RMDMAX72xxLedMatrix::setColumn1(byte buf, byte c, byte value){
    return led->setColumn(buf, c, value);
    }
    void B4RMDMAX72xxLedMatrix::control(B4RString* mode, int value){
    ::Serial.println(value);
 
    if (mode->data=="SHUTDOWN"){
      led->control(MD_MAX72XX::SHUTDOWN,  value);
    return;
    }
    if (mode->data=="SCANLIMIT"){
      led->control(MD_MAX72XX::SCANLIMIT,  value);
    return;
    }
    if (mode->data=="INTENSITY"){
      led->control(MD_MAX72XX::INTENSITY,  value);
    return;
    }
    if (mode->data=="TEST"){
      led->control(MD_MAX72XX::TEST,  value);                                                                                                            
    return;
    }
    if (mode->data=="DECODE"){
      led->control(MD_MAX72XX::DECODE,  value);
    return;
    }
    if (mode->data=="UPDATE"){
      led->control(MD_MAX72XX::UPDATE,  value);
    return;
    }
    if (mode->data=="WRAPAROUND"){
      led->control(MD_MAX72XX::WRAPAROUND,  value);
    return;
    }
    ::Serial.println("wrong mode selected");
    return;
    }
   
  // not testet
  bool  B4RMDMAX72xxLedMatrix::control1(byte dev, B4RString* mode, int value){
    if (mode->data=="SHUTDOWN"){
     return led->control(dev,MD_MAX72XX::SHUTDOWN,  value);
    }
    if (mode->data=="SCANLIMIT"){
     return led->control(dev,MD_MAX72XX::SCANLIMIT,  value);
    }
    if (mode->data=="INTENSITY"){
     return led->control(dev,MD_MAX72XX::INTENSITY,  value);
    }
    if (mode->data=="TEST"){
     return led->control(dev,MD_MAX72XX::TEST,  value);                                                                                                            
    }
    if (mode->data=="DECODE"){
     return led->control(dev,MD_MAX72XX::DECODE,  value);
    }
    if (mode->data=="UPDATE"){
     return led->control(dev,MD_MAX72XX::UPDATE,  value);
    }
    if (mode->data=="WRAPAROUND"){
    return led->control(dev,MD_MAX72XX::WRAPAROUND,  value);
    }
    ::Serial.println("wrong mode selected");
    return false;
    }

    bool B4RMDMAX72xxLedMatrix::control2(byte startDev, byte endDev, B4RString* mode, int value){
   if (mode->data=="SHUTDOWN"){
     return led->control(startDev,endDev,MD_MAX72XX::SHUTDOWN,  value);
    }
    if (mode->data=="SCANLIMIT"){
     return led->control(startDev,endDev,MD_MAX72XX::SCANLIMIT,  value);
    }
    if (mode->data=="INTENSITY"){
     return led->control(startDev,endDev,MD_MAX72XX::INTENSITY,  value);
    }
    if (mode->data=="TEST"){
     return led->control(startDev,endDev,MD_MAX72XX::TEST,  value);                                                                                                            
    }
    if (mode->data=="DECODE"){
     return led->control(startDev,endDev,MD_MAX72XX::DECODE,  value);
    }
    if (mode->data=="UPDATE"){
     return led->control(startDev,endDev,MD_MAX72XX::UPDATE,  value);
    }
    if (mode->data=="WRAPAROUND"){
    return led->control(startDev,endDev,MD_MAX72XX::WRAPAROUND,  value);
    }
    ::Serial.println("wrong mode selected");
    return false;
    } 


    void B4RMDMAX72xxLedMatrix::setModuleType(B4RString* mod){

    if (mod->data=="PAROLA_HW"){
    led->setModuleType(MD_MAX72XX::PAROLA_HW);
      return;    
    }
    else if (mod->data=="GENERIC_HW"){
      led->setModuleType(MD_MAX72XX::GENERIC_HW);
      return;    
    }
    else if (mod->data=="ICSTATION_HW"){
      led->setModuleType(MD_MAX72XX::ICSTATION_HW);
      return;   
    }
    else if (mod->data=="FC16_HW"){
      led->setModuleType(MD_MAX72XX::FC16_HW);
       return; 
    } 
    ::Serial.println("wrong hardware type");
    return;
    }
    void B4RMDMAX72xxLedMatrix::clear1(byte startDev, byte endDev){
    led->clear(startDev, endDev);
    }
    bool B4RMDMAX72xxLedMatrix::getBuffer(uint col, byte size, byte pd){
    return led->getBuffer(col, size, &pd);
    }
    byte B4RMDMAX72xxLedMatrix::getColumn(byte c) {
    return led->getColumn(c);
    }
    bool B4RMDMAX72xxLedMatrix::getPoint(byte r, uint c){
    return getPoint( r, c);
    }
    bool B4RMDMAX72xxLedMatrix::setBuffer(uint col, byte size, byte pd){
    return led->setBuffer(col, size, &pd);
    }
    bool B4RMDMAX72xxLedMatrix::setRow1(byte startDev, byte endDev, byte r, byte value){
    return led->setRow(startDev, endDev, r, value);
    }
    bool B4RMDMAX72xxLedMatrix::setRow2(byte buf, byte r, byte value){
    return led->setRow(buf,  r, value);
    }
    
    bool B4RMDMAX72xxLedMatrix::transform(B4RString* ttype){
    
    if (ttype->data=="TSL"){
		return led->transform(MD_MAX72XX::TSL);
    }
    if (ttype->data=="TSR"){
		return led->transform(MD_MAX72XX::TSR);
    }
    if (ttype->data=="TSU"){
		return led->transform(MD_MAX72XX::TSU);
    }
    if (ttype->data=="TSD"){
		return led->transform(MD_MAX72XX::TSD);
    }
    if (ttype->data=="TFLR"){
		return led->transform(MD_MAX72XX::TFLR);
    }
    if (ttype->data=="TFUD"){
		return led->transform(MD_MAX72XX::TFUD);
    }
    if (ttype->data=="TRC"){
		return led->transform(MD_MAX72XX::TRC);
    }
    if (ttype->data=="TINV"){
		return led->transform(MD_MAX72XX::TINV);
    }
    return false;
    }
    
    bool B4RMDMAX72xxLedMatrix::transform1(byte startDev, byte endDev, B4RString* ttype){
    if (ttype->data=="TSL"){
		return led->transform(startDev, endDev, MD_MAX72XX::TSL);
    }
    if (ttype->data=="TSR"){
		return led->transform(startDev, endDev, MD_MAX72XX::TSR);
    }
    if (ttype->data=="TSU"){
		return led->transform(startDev, endDev, MD_MAX72XX::TSU);
    }
    if (ttype->data=="TSD"){
		return led->transform(startDev, endDev, MD_MAX72XX::TSD);
    }
    if (ttype->data=="TFLR"){
		return led->transform(startDev, endDev, MD_MAX72XX::TFLR);
    }
    if (ttype->data=="TFUD"){
		return led->transform(startDev, endDev, MD_MAX72XX::TFUD);
    }
    if (ttype->data=="TRC"){
		return led->transform(startDev, endDev, MD_MAX72XX::TRC);
    }
    if (ttype->data=="TINV"){
		return led->transform(startDev, endDev, MD_MAX72XX::TINV);
    }
    return false;
    }

    
    bool B4RMDMAX72xxLedMatrix::transform2(byte buf, B4RString* ttype){
    if (ttype->data=="TSL"){
		return led->transform(buf, MD_MAX72XX::TSL);
    }
    if (ttype->data=="TSR"){
		return led->transform(buf, MD_MAX72XX::TSR);
    }
    if (ttype->data=="TSU"){
		return led->transform(buf, MD_MAX72XX::TSU);
    }
    if (ttype->data=="TSD"){
		return led->transform(buf, MD_MAX72XX::TSD);
    }
    if (ttype->data=="TFLR"){
		return led->transform(buf, MD_MAX72XX::TFLR);
    }
    if (ttype->data=="TFUD"){
		return led->transform(buf, MD_MAX72XX::TFUD);
    }
    if (ttype->data=="TRC"){
		return led->transform(buf, MD_MAX72XX::TRC);
    }
    if (ttype->data=="TINV"){
		return led->transform(buf, MD_MAX72XX::TINV);
    }
    return false;
    }
    
    void B4RMDMAX72xxLedMatrix::update( B4RString* mode){
    if (mode->data=="OFF"){
    led->update(MD_MAX72XX::OFF);
    return;
    }
    if (mode->data=="ON"){
    led->update(MD_MAX72XX::ON);
    return;
    }
    return;

    }
    void B4RMDMAX72xxLedMatrix::update1(void){
    led->update();
    }
    void B4RMDMAX72xxLedMatrix::update2(byte buf){
    led->update(buf);
    }
    
    void B4RMDMAX72xxLedMatrix::wraparound( B4RString* mode){
    if (mode->data=="OFF"){
    led->wraparound(MD_MAX72XX::OFF);
    return;
    }  
    if (mode->data=="ON"){
    led->wraparound(MD_MAX72XX::ON);
    return;
    }
    return;
    }
    byte B4RMDMAX72xxLedMatrix::getRow(byte buf, byte r){
    return led->getRow(buf, r);
    }
    byte B4RMDMAX72xxLedMatrix::getMaxFontWidth(void){
    return led->getMaxFontWidth();
    }
    byte B4RMDMAX72xxLedMatrix::getFontHeight(void){
    return led->getFontHeight();
    }

    byte B4RMDMAX72xxLedMatrix::getChar(byte c){
    return led->getChar(c, sizeof(aBuf) / sizeof(aBuf[0]), aBuf);
    } 

    bool B4RMDMAX72xxLedMatrix::setColumn(byte c, byte value) {
    return led->setColumn(c, aBuf[value]);
    } 

// getchar1 testing with buffer..... dont work :(    
    
    byte B4RMDMAX72xxLedMatrix::getChar1(byte c, byte size, byte buf){
    return led->getChar(c, size, &buf);
    }
    
 }
 
// Test

 
/*    void B4RMDMAX72xxLedMatrix::scrollText_left(char *p, uint pause)
{
  uint8_t charWidth;
  uint8_t aBuf[8];  // this should be ok for all built-in fonts

  led->clear();

  while (*p != '\0')
  {
  ::Serial.println("chr: ");
  ::Serial.println(*p);
  ::Serial.println("size of cbuf: ");
  ::Serial.println(sizeof(aBuf) / sizeof(aBuf[0]));
  ::Serial.println("cbuf: ");
  ::Serial.println(*aBuf);
    //charWidth = led->getChar(*p++, sizeof(aBuf) / sizeof(aBuf[0]), aBuf);
    charWidth = led->getChar(104, 8, aBuf);
  ::Serial.println("charWidth: ");
  ::Serial.println(charWidth);
    for (uint8_t i=0; i<=charWidth; i++)	// allow space between characters
    {
      led->transform(MD_MAX72XX::TSL);
      if (i < charWidth)
        led->setColumn(0, aBuf[i]);
  ::Serial.println("cbufi: ");
  ::Serial.println(aBuf[i]);
      delay(pause);
    }
  }
} */
    


 
  