#pragma once
#include "B4RDefines.h"
//~Version: 1.0
//~DependsOn: <MD_MAX72xx.h>


namespace B4R {
	//~shortname: MD72xxLedMatrix
  //~Author: A.Dalebout
	class B4RMDMAX72xxLedMatrix {
  		private:
			uint8_t be[sizeof(MD_MAX72XX)];
			MD_MAX72XX* led;
      void scrollText_left(char *p, uint pause);
      uint8_t charWidth;
uint8_t aBuf[8];  // test
		public:
      enum controlValue_t { OFF = 0,  ON = 1};
    //~hide
    static B4RString* StringToB4R(String* s);
    // Hardware Type:
    //PAROLA_HW
    //GENERIC_HW
    //ICSTATION_HW
    //FC16_HW
    void Initialize(B4RString* HARDWARE_TYPE_b, int MAX_DEVICES, int CS_PIN);
    // Hardware Type:
    //PAROLA_HW
    //GENERIC_HW
    //ICSTATION_HW
    //FC16_HW
    void Initialize2(B4RString* HARDWARE_TYPE_b, int MAX_DEVICES, int DATA_PIN, int CLK_PIN, int CS_PIN);
    void clear();
    void clear1(byte startDev, byte endDev);
    bool setPoint(byte r, byte c, bool state);
    bool setRow(byte r, byte value);
    bool setRow1(byte startDev, byte endDev, byte r, byte value);
    bool setRow2(byte buf, byte r, byte value);
    bool setColumn(byte c, byte value);
    bool setColum(byte c, byte value);
    bool setColumn1(byte buf, byte c, byte value);
    void setModuleType(B4RString* mod);
    uint setChar(byte col, byte c);
    bool setFont(MD_MAX72XX::fontType_t *f);
    bool setBuffer(uint col, byte size, byte pd);    
    uint getDeviceCount(void);
    uint getColumnCount(void);
    bool getBuffer(uint col, byte size, byte pd);
    byte getColumn(byte c);
    byte getRow(byte buf, byte r);
    bool getPoint(byte r, uint c);
    byte getMaxFontWidth(void);
    byte getFontHeight(void); 
    bool control1(byte dev, B4RString* mode, int value);
    void control(B4RString* mode, int value);
    bool control2(byte startDev, byte endDev, B4RString* mode, int value);
    bool transform(B4RString* ttype);
    bool transform1(byte startDev, byte endDev, B4RString* ttype);
    bool transform2(byte buf, B4RString* ttype);
    void update( B4RString* mode);
    void update1(void);
    void update2(byte buf);
    void wraparound(B4RString* mode);

    void wait(ulong waitms);
    void scrollTextleft(B4RString* pp, uint lenght, uint pause);
    byte getChar(byte c); 
  
    //  getchar1 testing with buffer..... dont work :(   
    
    byte getChar1(byte c, byte size, byte buf);

  

    };
    }